Chapter 15. ConfigService


15.1. GetConfig

GET /v1/config

15.1.1. Description

15.1.2. Parameters

15.1.3. Return Type

StorageConfig

15.1.4. Content Type

  • application/json

15.1.5. Responses

Expand
Table 15.1. HTTP Response Codes
CodeMessageDatatype

200

A successful response.

StorageConfig

0

An unexpected error response.

RuntimeError

15.1.6. Samples

15.1.7. Common object reference

15.1.7.1. BannerConfigSize

Expand
Enum Values

UNSET

SMALL

MEDIUM

LARGE

15.1.7.2. ProtobufAny

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
  ...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
  ...
}

The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".

15.1.7.2.1. JSON representation

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}
{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
Expand
Field NameRequiredNullableTypeDescriptionFormat

typeUrl

  

String

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading \".\" is not accepted). In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows: * If no scheme is provided, https is assumed. * An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error. * Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.) Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one. Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

 

value

  

byte[]

Must be a valid serialized protocol buffer of the above specified type.

byte

15.1.7.3. RuntimeError

Expand
Field NameRequiredNullableTypeDescriptionFormat

error

  

String

  

code

  

Integer

 

int32

message

  

String

  

details

  

List of ProtobufAny

  

15.1.7.4. StorageAdministrationEventsConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

retentionDurationDays

  

Long

 

int64

15.1.7.5. StorageAlertRetentionConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

resolvedDeployRetentionDurationDays

  

Integer

 

int32

deletedRuntimeRetentionDurationDays

  

Integer

This runtime alert retention configuration takes precedence after allRuntimeRetentionDurationDays.

int32

allRuntimeRetentionDurationDays

  

Integer

This runtime alert retention configuration has highest precedence. All runtime alerts, including attempted alerts and deleted deployment alerts, are deleted even if respective retention is longer.

int32

attemptedDeployRetentionDurationDays

  

Integer

 

int32

attemptedRuntimeRetentionDurationDays

  

Integer

This runtime alert retention configuration has lowest precedence.

int32

15.1.7.6. StorageBannerConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

enabled

  

Boolean

  

text

  

String

  

size

  

BannerConfigSize

 

UNSET, SMALL, MEDIUM, LARGE,

color

  

String

  

backgroundColor

  

String

  

15.1.7.7. StorageConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

publicConfig

  

StoragePublicConfig

  

privateConfig

  

StoragePrivateConfig

  

15.1.7.8. StorageDayOption

Expand
Field NameRequiredNullableTypeDescriptionFormat

numDays

  

Long

 

int64

enabled

  

Boolean

  
next available tag: 5
Expand
Field NameRequiredNullableTypeDescriptionFormat

retentionDurationDays

  

Integer

 

int32

ignoreClusterLabels

  

Map of string

  

lastUpdated

  

Date

 

date-time

createdAt

  

Date

 

date-time

15.1.7.10. StorageLoginNotice

Expand
Field NameRequiredNullableTypeDescriptionFormat

enabled

  

Boolean

  

text

  

String

  

15.1.7.11. StoragePrivateConfig

next available tag:9
Expand
Field NameRequiredNullableTypeDescriptionFormat

DEPRECATEDAlertRetentionDurationDays

  

Integer

 

int32

alertConfig

  

StorageAlertRetentionConfig

  

imageRetentionDurationDays

  

Integer

 

int32

expiredVulnReqRetentionDurationDays

  

Integer

 

int32

decommissionedClusterRetention

  

StorageDecommissionedClusterRetentionConfig

  

reportRetentionConfig

  

StorageReportRetentionConfig

  

vulnerabilityExceptionConfig

  

StorageVulnerabilityExceptionConfig

  

administrationEventsConfig

  

StorageAdministrationEventsConfig

  

15.1.7.12. StoragePublicConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

loginNotice

  

StorageLoginNotice

  

header

  

StorageBannerConfig

  

footer

  

StorageBannerConfig

  

telemetry

  

StorageTelemetryConfiguration

  

15.1.7.13. StorageReportRetentionConfig

next available tag: 4
Expand
Field NameRequiredNullableTypeDescriptionFormat

historyRetentionDurationDays

  

Long

 

int64

downloadableReportRetentionDays

  

Long

 

int64

downloadableReportGlobalRetentionBytes

  

Long

 

int64

15.1.7.14. StorageTelemetryConfiguration

Expand
Field NameRequiredNullableTypeDescriptionFormat

enabled

  

Boolean

  

lastSetTime

  

Date

 

date-time

15.1.7.15. StorageVulnerabilityExceptionConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

expiryOptions

  

StorageVulnerabilityExceptionConfigExpiryOptions

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

dayOptions

  

List of StorageDayOption

  

fixableCveOptions

  

StorageVulnerabilityExceptionConfigFixableCVEOptions

  

customDate

  

Boolean

  

indefinite

  

Boolean

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

allFixable

  

Boolean

  

anyFixable

  

Boolean

  

15.2. GetVulnerabilityExceptionConfig

GET /v1/config/private/exception/vulnerabilities

15.2.1. Description

15.2.2. Parameters

15.2.3. Return Type

V1GetVulnerabilityExceptionConfigResponse

15.2.4. Content Type

  • application/json

15.2.5. Responses

Expand
Table 15.2. HTTP Response Codes
CodeMessageDatatype

200

A successful response.

V1GetVulnerabilityExceptionConfigResponse

0

An unexpected error response.

RuntimeError

15.2.6. Samples

15.2.7. Common object reference

15.2.7.1. ProtobufAny

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
  ...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
  ...
}

The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".

15.2.7.1.1. JSON representation

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}
{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
Expand
Field NameRequiredNullableTypeDescriptionFormat

typeUrl

  

String

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading \".\" is not accepted). In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows: * If no scheme is provided, https is assumed. * An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error. * Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.) Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one. Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

 

value

  

byte[]

Must be a valid serialized protocol buffer of the above specified type.

byte

15.2.7.2. RuntimeError

Expand
Field NameRequiredNullableTypeDescriptionFormat

error

  

String

  

code

  

Integer

 

int32

message

  

String

  

details

  

List of ProtobufAny

  

15.2.7.3. V1DayOption

Expand
Field NameRequiredNullableTypeDescriptionFormat

numDays

  

Long

 

int64

enabled

  

Boolean

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

config

  

V1VulnerabilityExceptionConfig

  

15.2.7.5. V1VulnerabilityExceptionConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

expiryOptions

  

V1VulnerabilityExceptionConfigExpiryOptions

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

dayOptions

  

List of V1DayOption

This allows users to set expiry interval based on number of days.

 

fixableCveOptions

  

V1VulnerabilityExceptionConfigFixableCVEOptions

  

customDate

  

Boolean

This option, if true, allows UI to show a custom date picker for setting expiry date.

 

indefinite

  

Boolean

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

allFixable

  

Boolean

This options allows users to expire the vulnerability deferral request if and only if all vulnerabilities in the requests become fixable.

 

anyFixable

  

Boolean

This options allows users to expire the vulnerability deferral request if any vulnerability in the requests become fixable.

 

15.3. UpdateVulnerabilityExceptionConfig

PUT /v1/config/private/exception/vulnerabilities

15.3.1. Description

15.3.2. Parameters

15.3.2.1. Body Parameter

Expand
NameDescriptionRequiredDefaultPattern

body

V1UpdateVulnerabilityExceptionConfigRequest

X

  

15.3.3. Return Type

V1UpdateVulnerabilityExceptionConfigResponse

15.3.4. Content Type

  • application/json

15.3.5. Responses

Expand
Table 15.3. HTTP Response Codes
CodeMessageDatatype

200

A successful response.

V1UpdateVulnerabilityExceptionConfigResponse

0

An unexpected error response.

RuntimeError

15.3.6. Samples

15.3.7. Common object reference

15.3.7.1. ProtobufAny

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
  ...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
  ...
}

The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".

15.3.7.1.1. JSON representation

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}
{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
Expand
Field NameRequiredNullableTypeDescriptionFormat

typeUrl

  

String

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading \".\" is not accepted). In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows: * If no scheme is provided, https is assumed. * An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error. * Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.) Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one. Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

 

value

  

byte[]

Must be a valid serialized protocol buffer of the above specified type.

byte

15.3.7.2. RuntimeError

Expand
Field NameRequiredNullableTypeDescriptionFormat

error

  

String

  

code

  

Integer

 

int32

message

  

String

  

details

  

List of ProtobufAny

  

15.3.7.3. V1DayOption

Expand
Field NameRequiredNullableTypeDescriptionFormat

numDays

  

Long

 

int64

enabled

  

Boolean

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

config

  

V1VulnerabilityExceptionConfig

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

config

  

V1VulnerabilityExceptionConfig

  

15.3.7.6. V1VulnerabilityExceptionConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

expiryOptions

  

V1VulnerabilityExceptionConfigExpiryOptions

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

dayOptions

  

List of V1DayOption

This allows users to set expiry interval based on number of days.

 

fixableCveOptions

  

V1VulnerabilityExceptionConfigFixableCVEOptions

  

customDate

  

Boolean

This option, if true, allows UI to show a custom date picker for setting expiry date.

 

indefinite

  

Boolean

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

allFixable

  

Boolean

This options allows users to expire the vulnerability deferral request if and only if all vulnerabilities in the requests become fixable.

 

anyFixable

  

Boolean

This options allows users to expire the vulnerability deferral request if any vulnerability in the requests become fixable.

 

15.4. GetPrivateConfig

GET /v1/config/private

15.4.1. Description

15.4.2. Parameters

15.4.3. Return Type

StoragePrivateConfig

15.4.4. Content Type

  • application/json

15.4.5. Responses

Expand
Table 15.4. HTTP Response Codes
CodeMessageDatatype

200

A successful response.

StoragePrivateConfig

0

An unexpected error response.

RuntimeError

15.4.6. Samples

15.4.7. Common object reference

15.4.7.1. ProtobufAny

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
  ...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
  ...
}

The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".

15.4.7.1.1. JSON representation

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}
{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
Expand
Field NameRequiredNullableTypeDescriptionFormat

typeUrl

  

String

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading \".\" is not accepted). In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows: * If no scheme is provided, https is assumed. * An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error. * Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.) Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one. Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

 

value

  

byte[]

Must be a valid serialized protocol buffer of the above specified type.

byte

15.4.7.2. RuntimeError

Expand
Field NameRequiredNullableTypeDescriptionFormat

error

  

String

  

code

  

Integer

 

int32

message

  

String

  

details

  

List of ProtobufAny

  

15.4.7.3. StorageAdministrationEventsConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

retentionDurationDays

  

Long

 

int64

15.4.7.4. StorageAlertRetentionConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

resolvedDeployRetentionDurationDays

  

Integer

 

int32

deletedRuntimeRetentionDurationDays

  

Integer

This runtime alert retention configuration takes precedence after allRuntimeRetentionDurationDays.

int32

allRuntimeRetentionDurationDays

  

Integer

This runtime alert retention configuration has highest precedence. All runtime alerts, including attempted alerts and deleted deployment alerts, are deleted even if respective retention is longer.

int32

attemptedDeployRetentionDurationDays

  

Integer

 

int32

attemptedRuntimeRetentionDurationDays

  

Integer

This runtime alert retention configuration has lowest precedence.

int32

15.4.7.5. StorageDayOption

Expand
Field NameRequiredNullableTypeDescriptionFormat

numDays

  

Long

 

int64

enabled

  

Boolean

  
next available tag: 5
Expand
Field NameRequiredNullableTypeDescriptionFormat

retentionDurationDays

  

Integer

 

int32

ignoreClusterLabels

  

Map of string

  

lastUpdated

  

Date

 

date-time

createdAt

  

Date

 

date-time

15.4.7.7. StoragePrivateConfig

next available tag:9
Expand
Field NameRequiredNullableTypeDescriptionFormat

DEPRECATEDAlertRetentionDurationDays

  

Integer

 

int32

alertConfig

  

StorageAlertRetentionConfig

  

imageRetentionDurationDays

  

Integer

 

int32

expiredVulnReqRetentionDurationDays

  

Integer

 

int32

decommissionedClusterRetention

  

StorageDecommissionedClusterRetentionConfig

  

reportRetentionConfig

  

StorageReportRetentionConfig

  

vulnerabilityExceptionConfig

  

StorageVulnerabilityExceptionConfig

  

administrationEventsConfig

  

StorageAdministrationEventsConfig

  

15.4.7.8. StorageReportRetentionConfig

next available tag: 4
Expand
Field NameRequiredNullableTypeDescriptionFormat

historyRetentionDurationDays

  

Long

 

int64

downloadableReportRetentionDays

  

Long

 

int64

downloadableReportGlobalRetentionBytes

  

Long

 

int64

15.4.7.9. StorageVulnerabilityExceptionConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

expiryOptions

  

StorageVulnerabilityExceptionConfigExpiryOptions

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

dayOptions

  

List of StorageDayOption

  

fixableCveOptions

  

StorageVulnerabilityExceptionConfigFixableCVEOptions

  

customDate

  

Boolean

  

indefinite

  

Boolean

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

allFixable

  

Boolean

  

anyFixable

  

Boolean

  

15.5. GetPublicConfig

GET /v1/config/public

15.5.1. Description

15.5.2. Parameters

15.5.3. Return Type

StoragePublicConfig

15.5.4. Content Type

  • application/json

15.5.5. Responses

Expand
Table 15.5. HTTP Response Codes
CodeMessageDatatype

200

A successful response.

StoragePublicConfig

0

An unexpected error response.

RuntimeError

15.5.6. Samples

15.5.7. Common object reference

15.5.7.1. BannerConfigSize

Expand
Enum Values

UNSET

SMALL

MEDIUM

LARGE

15.5.7.2. ProtobufAny

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
  ...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
  ...
}

The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".

15.5.7.2.1. JSON representation

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}
{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
Expand
Field NameRequiredNullableTypeDescriptionFormat

typeUrl

  

String

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading \".\" is not accepted). In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows: * If no scheme is provided, https is assumed. * An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error. * Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.) Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one. Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

 

value

  

byte[]

Must be a valid serialized protocol buffer of the above specified type.

byte

15.5.7.3. RuntimeError

Expand
Field NameRequiredNullableTypeDescriptionFormat

error

  

String

  

code

  

Integer

 

int32

message

  

String

  

details

  

List of ProtobufAny

  

15.5.7.4. StorageBannerConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

enabled

  

Boolean

  

text

  

String

  

size

  

BannerConfigSize

 

UNSET, SMALL, MEDIUM, LARGE,

color

  

String

  

backgroundColor

  

String

  

15.5.7.5. StorageLoginNotice

Expand
Field NameRequiredNullableTypeDescriptionFormat

enabled

  

Boolean

  

text

  

String

  

15.5.7.6. StoragePublicConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

loginNotice

  

StorageLoginNotice

  

header

  

StorageBannerConfig

  

footer

  

StorageBannerConfig

  

telemetry

  

StorageTelemetryConfiguration

  

15.5.7.7. StorageTelemetryConfiguration

Expand
Field NameRequiredNullableTypeDescriptionFormat

enabled

  

Boolean

  

lastSetTime

  

Date

 

date-time

15.6. PutConfig

PUT /v1/config

15.6.1. Description

15.6.2. Parameters

15.6.2.1. Body Parameter

Expand
NameDescriptionRequiredDefaultPattern

body

V1PutConfigRequest

X

  

15.6.3. Return Type

StorageConfig

15.6.4. Content Type

  • application/json

15.6.5. Responses

Expand
Table 15.6. HTTP Response Codes
CodeMessageDatatype

200

A successful response.

StorageConfig

0

An unexpected error response.

RuntimeError

15.6.6. Samples

15.6.7. Common object reference

15.6.7.1. BannerConfigSize

Expand
Enum Values

UNSET

SMALL

MEDIUM

LARGE

15.6.7.2. ProtobufAny

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
  ...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
  ...
}

The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".

15.6.7.2.1. JSON representation

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}
{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
Expand
Field NameRequiredNullableTypeDescriptionFormat

typeUrl

  

String

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading \".\" is not accepted). In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows: * If no scheme is provided, https is assumed. * An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error. * Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.) Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one. Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

 

value

  

byte[]

Must be a valid serialized protocol buffer of the above specified type.

byte

15.6.7.3. RuntimeError

Expand
Field NameRequiredNullableTypeDescriptionFormat

error

  

String

  

code

  

Integer

 

int32

message

  

String

  

details

  

List of ProtobufAny

  

15.6.7.4. StorageAdministrationEventsConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

retentionDurationDays

  

Long

 

int64

15.6.7.5. StorageAlertRetentionConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

resolvedDeployRetentionDurationDays

  

Integer

 

int32

deletedRuntimeRetentionDurationDays

  

Integer

This runtime alert retention configuration takes precedence after allRuntimeRetentionDurationDays.

int32

allRuntimeRetentionDurationDays

  

Integer

This runtime alert retention configuration has highest precedence. All runtime alerts, including attempted alerts and deleted deployment alerts, are deleted even if respective retention is longer.

int32

attemptedDeployRetentionDurationDays

  

Integer

 

int32

attemptedRuntimeRetentionDurationDays

  

Integer

This runtime alert retention configuration has lowest precedence.

int32

15.6.7.6. StorageBannerConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

enabled

  

Boolean

  

text

  

String

  

size

  

BannerConfigSize

 

UNSET, SMALL, MEDIUM, LARGE,

color

  

String

  

backgroundColor

  

String

  

15.6.7.7. StorageConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

publicConfig

  

StoragePublicConfig

  

privateConfig

  

StoragePrivateConfig

  

15.6.7.8. StorageDayOption

Expand
Field NameRequiredNullableTypeDescriptionFormat

numDays

  

Long

 

int64

enabled

  

Boolean

  
next available tag: 5
Expand
Field NameRequiredNullableTypeDescriptionFormat

retentionDurationDays

  

Integer

 

int32

ignoreClusterLabels

  

Map of string

  

lastUpdated

  

Date

 

date-time

createdAt

  

Date

 

date-time

15.6.7.10. StorageLoginNotice

Expand
Field NameRequiredNullableTypeDescriptionFormat

enabled

  

Boolean

  

text

  

String

  

15.6.7.11. StoragePrivateConfig

next available tag:9
Expand
Field NameRequiredNullableTypeDescriptionFormat

DEPRECATEDAlertRetentionDurationDays

  

Integer

 

int32

alertConfig

  

StorageAlertRetentionConfig

  

imageRetentionDurationDays

  

Integer

 

int32

expiredVulnReqRetentionDurationDays

  

Integer

 

int32

decommissionedClusterRetention

  

StorageDecommissionedClusterRetentionConfig

  

reportRetentionConfig

  

StorageReportRetentionConfig

  

vulnerabilityExceptionConfig

  

StorageVulnerabilityExceptionConfig

  

administrationEventsConfig

  

StorageAdministrationEventsConfig

  

15.6.7.12. StoragePublicConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

loginNotice

  

StorageLoginNotice

  

header

  

StorageBannerConfig

  

footer

  

StorageBannerConfig

  

telemetry

  

StorageTelemetryConfiguration

  

15.6.7.13. StorageReportRetentionConfig

next available tag: 4
Expand
Field NameRequiredNullableTypeDescriptionFormat

historyRetentionDurationDays

  

Long

 

int64

downloadableReportRetentionDays

  

Long

 

int64

downloadableReportGlobalRetentionBytes

  

Long

 

int64

15.6.7.14. StorageTelemetryConfiguration

Expand
Field NameRequiredNullableTypeDescriptionFormat

enabled

  

Boolean

  

lastSetTime

  

Date

 

date-time

15.6.7.15. StorageVulnerabilityExceptionConfig

Expand
Field NameRequiredNullableTypeDescriptionFormat

expiryOptions

  

StorageVulnerabilityExceptionConfigExpiryOptions

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

dayOptions

  

List of StorageDayOption

  

fixableCveOptions

  

StorageVulnerabilityExceptionConfigFixableCVEOptions

  

customDate

  

Boolean

  

indefinite

  

Boolean

  
Expand
Field NameRequiredNullableTypeDescriptionFormat

allFixable

  

Boolean

  

anyFixable

  

Boolean

  

15.6.7.18. V1PutConfigRequest

Expand
Field NameRequiredNullableTypeDescriptionFormat

config

  

StorageConfig

  
Red Hat logoGithubredditYoutubeTwitter

Learn

Try, buy, & sell

Communities

About Red Hat

We deliver hardened solutions that make it easier for enterprises to work across platforms and environments, from the core datacenter to the network edge.

Making open source more inclusive

Red Hat is committed to replacing problematic language in our code, documentation, and web properties. For more details, see the Red Hat Blog.

About Red Hat Documentation

Legal Notice

Theme

© 2026 Red Hat
Back to top